
#include "BinaryTree.h"
#include "common.h"

/*	 Ʈ 带   ʱȭϰ ȯϴ Լ	*/
BTreeNode* MakeBTreeNode(void)
{
	BTreeNode* newNode = (BTreeNode*)malloc(sizeof(BTreeNode));

	newNode->leftChild = NULL;
	newNode->rightChild = NULL;

	return newNode;
}

/*	pMain ʿ pSub Ʈ Ѵ.	*/
void MakeLeftSubTree(BTreeNode* pMain, BTreeNode* pSub)
{
	if (pMain->leftChild != NULL)
		free(pMain->leftChild);

	pMain->leftChild = pSub;
}

/*	pMain ʿ pSub Ʈ Ѵ.	*/
void MakeRightSubTree(BTreeNode* pMain, BTreeNode* pSub)
{
	if (pMain->rightChild != NULL)
		free(pMain->rightChild);

	pMain->rightChild = pSub;
}

/*	忡 ͸ ϴ Լ	*/
void SetData(BTreeNode* pNode, int iData)
{
	pNode->iData = iData;
}

/*	忡  ͸ ȯϴ Լ	*/
int GetData(BTreeNode* pNode)
{
	return pNode->iData;
}

/*	 Ʈ 带  ϰ ͸ ϰ 带 ȯϴ Լ	*/
BTreeNode* MakeBTreeNodeAndSetData(int iData)
{
	BTreeNode* newNode = MakeBTreeNode();

	SetData(newNode, iData);

	return newNode;
}

/*	  ڽ ȯϴ Լ	*/
BTreeNode* GetLeftSubTree(BTreeNode* pNode)
{
	return (pNode->leftChild);
}

/*	  ڽ ȯϴ Լ	*/
BTreeNode* GetRightSubTree(BTreeNode* pNode)
{
	return (pNode->rightChild);
}

/*	 ȸ	*/
void PreorderTraversal(BTreeNode* pNode)
{
	/*	 Լ Ż 	*/
	if (pNode == NULL)
		return;

	printf("%d ", GetData(pNode));
	PreorderTraversal(GetLeftSubTree(pNode));
	PreorderTraversal(GetRightSubTree(pNode));
}

/*	 ȸ	*/
void InorderTraversal(BTreeNode* pNode)
{
	/*	 Լ Ż 	*/
	if (pNode == NULL)
		return;

	InorderTraversal(GetLeftSubTree(pNode));
	printf("%d ", GetData(pNode));
	InorderTraversal(GetRightSubTree(pNode));
}

/*	 ȸ	*/
void PostorderTraversal(BTreeNode* pNode)
{
	/*	 Լ Ż 	*/
	if (pNode == NULL)
		return;

	PostorderTraversal(GetLeftSubTree(pNode));
	PostorderTraversal(GetRightSubTree(pNode));
	printf("%d ", GetData(pNode));
}

/*	 ȸ ̿Ͽ   Լ	*/
void DeleteTree(BTreeNode* pNode)
{
	/*	 Լ Ż 	*/
	if (pNode == NULL)
		return;

	DeleteTree(GetLeftSubTree(pNode));
	DeleteTree(GetRightSubTree(pNode));

	/*	 Ʈ 尡  Ǵ ˾ƺ.	*/
	printf("Delete Node Data : %d\n", GetData(pNode));	

	free(pNode);
}